﻿/**
 * Copyright 2009 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Pena <manuel.delapena@canonical.com>
 */
using Canonical.UbuntuOne.Common.Validation;
using NUnit.Framework;

namespace Canonical.UbuntuOne.Common.Tests.Validation
{
    [TestFixture]
    public class EqualityExtensionsValidation
    {
        #region Tests

        [Test]
        public void IsGreaterThanTrueTest()
        {
            ValidateArgs.Begin()
                .IsGreaterThan(4, 3, "should be greater")
                .Check();
        }

        [Test]
        [ExpectedException(typeof(ValidationException))]
        public void IsGreaterThanFalseTest()
        {
            ValidateArgs.Begin()
                .IsGreaterThan(3, 4, "should be greater")
                .Check();
        }

        [Test]
        public void IsGreaterOrEqualTrueTest()
        {
            ValidateArgs.Begin()
                .IsGreaterOrEqualThan(4, 4, "Is equal")
                .IsGreaterOrEqualThan(5,4, "Is Greater")
                .Check();
        }

        [Test]
        [ExpectedException(typeof(ValidationException))]
        public void IsGreaterOrEqualFalseTest()
        {
            ValidateArgs.Begin()
                .IsGreaterOrEqualThan(3, 4, "Is smaller")
                .Check();
                
        }

        [Test]
        public void IsEqualTrueTest()
        {
            ValidateArgs.Begin()
                .IsEqual(3, 3)
                .Check();
        }

        [Test]
        [ExpectedException(typeof(ValidationException))]
        public void IsEqualFalseTest()
        {
            ValidateArgs.Begin()
                .IsEqual(3, 4)
                .Check();
        }
        
        #endregion

    }
}
