﻿/**
 * Copyright 2009 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Pena <manuel.delapena@canonical.com>
 */
using System.ServiceModel;

namespace Canonical.UbuntuOne.Common
{
	/// <summary>
	/// The implementators of this interface should allow the callng clients to perform a number of applications on 
	/// the sync daemon from windows. This will allow users to interact with the daemon through .Net.
	/// </summary>
	[ServiceContract(Namespace = "http://one.ubuntu.com")]
	public interface ISyncDaemon
	{
		/// <summary>
		/// Allows to start the daemon by a client.
		/// </summary>
		[OperationContract]
		void Start();
		
		/// <summary>
		/// Allows to try and start a daemon from the client. If the daemon cannot be started a false will be returned.
		/// </summary>
		/// <returns>A boolean flag telling if the daemon could be started.</returns>
		[OperationContract]
		bool TryStart();
		
		/// <summary>
		/// Allows to stop the daemon by a client.
		/// </summary>
		[OperationContract]
		void Stop();
		
		/// <summary>
		/// Allows to try and stop the daemon from the client. If the daemon cannot be stopped a false will be returned.
		/// </summary>
		/// <returns>A boolean flag telling if the daemong could bs stopped.</returns>
		[OperationContract]
		bool TryStop();
	}
}
