﻿/**
 * Copyright 2009 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Pena <manuel.delapena@canonical.com>
 */
using ProtoBuf;

namespace Canonical.UbuntuOne.ProcessDispatcher
{
    /// <summary>
    /// This class represents the proto contract that is used to communicate between the python process and 
    /// the .Net process using named pipes. The .Net applications should not have knowledge of this since it is 
    /// an implementation detail. .Net clients should use WCF which represents the more stable API.
    /// </summary>
    [ProtoContract]
    internal class DownloadProto : NodeProto
    {
        /// <summary>
        /// Gets and sets the number of bytes read so far.
        /// </summary>
        [ProtoMember(4)]
        public int NumberOfBytesRead { get; set; }
    }
}
