﻿/**
 * Copyright 2009 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Pena <manuel.delapena@canonical.com>
 */
using ProtoBuf;

namespace Canonical.UbuntuOne.ProcessDispatcher
{
    /// <summary>
    /// This class represents the proto contract that is used to communicate between the python process and 
    /// the .Net process using named pipes. The .Net applications should not have knowledge of this since it is 
    /// an implementation detail. .Net clients should use WCF which represents the more stable API.
    /// </summary>
    [ProtoContract]
    internal class StateProto
    {
        //TOdO: This should be an enum, never a string

        /// <summary>
        /// Gets and sets the name of the state.
        /// </summary>
        [ProtoMember(1)]
        public string Name { get; set; }

        /// <summary>
        /// Gets and sets the description of the state.
        /// </summary>
        [ProtoMember(2)]
        public string Description { get; set; }

        /// <summary>
        /// Gets and sets if the state is an error.
        /// </summary>
        [ProtoMember(3)]
        public bool IsError { get; set; }

        /// <summary>
        /// Gets and sets if the daemon is connected or not.
        /// </summary>
        [ProtoMember(4)]
        public bool IsConnected { get; set; }

        /// <summary>
        /// Gets and sets of the daemon is online or not.
        /// </summary>
        [ProtoMember(5)]
        public bool IsOnline { get; set; }
    }
}
